VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "COptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private genListN As String
Private defGenre As Byte
Private strtDir As String
Private FUp As String
Private ROnly As Boolean
Private NConv As Boolean
Private Er As Boolean
Private CTr As Boolean
Private RecS As String
  ' contains 1 for round par, 2 for square par, 3 for space,
  ' 4 for square par&space, 5 for intelligent
Private ConvTo As Integer
  ' 1 for round par, 2 for square par, 3 for space
  ' 4 for square par&space
Private ConvUS As String
Private play As String
Private iinc As String
Private fempty As Boolean
Private tno As Byte
  ' 0 no track no, 1 track no between, 2 track no beginning
Private low As Boolean

Public Property Get genListName() As String
    genListName = genListN
End Property

Public Property Let genListName(ByVal n As String)
    genListN = n
End Property

Public Property Get defaultGenre() As Byte
    defaultGenre = defGenre
End Property

Public Property Let defaultGenre(ByVal d As Byte)
    defGenre = d
End Property

Public Property Get startDir() As String
    startDir = strtDir
End Property

Public Property Let startDir(ByVal s As String)
    strtDir = s
End Property

Public Property Get FillUp() As String
    FillUp = FUp
End Property

Public Property Let FillUp(ByVal s As String)
    FUp = s
End Property

Public Property Get AskReadOnly() As Boolean
    AskReadOnly = ROnly
End Property

Public Property Let AskReadOnly(ByVal b As Boolean)
    ROnly = b
End Property

Public Property Get NextConvert() As Boolean
    NextConvert = NConv
End Property

Public Property Let NextConvert(ByVal b As Boolean)
    NConv = b
End Property

Public Property Get ShowMp3Error() As Boolean
    ShowMp3Error = Er
End Property

Public Property Let ShowMp3Error(e As Boolean)
    Er = e
End Property

Public Property Get RecognizeRoundPar() As Boolean
    RecognizeRoundPar = InStr(1, RecS, "1")
End Property

Public Property Get RecognizeSquarePar() As Boolean
    RecognizeSquarePar = InStr(1, RecS, "2")
End Property

Public Property Get RecognizeSpace() As Boolean
    RecognizeSpace = InStr(1, RecS, "3")
End Property

Public Property Get RecognizeSquareSpace() As Boolean
    RecognizeSquareSpace = InStr(1, RecS, "4")
End Property

Public Property Get RecognizeIntelligent() As Boolean
    RecognizeIntelligent = InStr(1, RecS, "5")
End Property

Public Property Let RecognizeString(s As String)
    RecS = s
End Property

Public Property Get ConvertToRoundPar() As Boolean
    ConvertToRoundPar = (ConvTo = 1)
End Property

Public Property Get ConvertToSquarePar() As Boolean
    ConvertToSquarePar = (ConvTo = 2)
End Property

Public Property Get ConvertToSpace() As Boolean
    ConvertToSpace = (ConvTo = 3)
End Property

Public Property Get ConvertToSquareSpace() As Boolean
    ConvertToSquareSpace = (ConvTo = 4)
End Property

Public Property Let ConvertTo(i As Integer)
    ConvTo = i
End Property

Public Property Get ConvertUnderscore() As Boolean
    ConvertUnderscore = ConvUS
End Property

Public Property Let ConvertUnderscore(b As Boolean)
    ConvUS = b
End Property

Public Property Get mp3Player() As String
    mp3Player = play
End Property

Public Property Let mp3Player(s As String)
    play = s
End Property

Public Property Get InfoInclude() As String
    InfoInclude = iinc
End Property

Public Property Let InfoInclude(s As String)
    iinc = s
End Property

Public Property Get FillOnlyEmpty() As Boolean
    FillOnlyEmpty = fempty
End Property

Public Property Let FillOnlyEmpty(b As Boolean)
    fempty = b
End Property

Public Property Get TrackNo() As Byte
    TrackNo = tno
End Property

Public Property Let TrackNo(b As Byte)
    tno = b
End Property

Public Property Get Lowercase() As Boolean
    Lowercase = low
End Property

Public Property Let Lowercase(b As Boolean)
    low = b
End Property

Public Sub readOptions()
    Dim fn As String
    If right(App.Path, 1) <> "\" Then
        fn = App.Path & "\"
    Else
        fn = App.Path
    End If
    genListN = GetSetting("NightmaresID3Tagger", "Options", "GenreListName", fn & "genre.gls")
    defGenre = GetSetting("NightmaresID3Tagger", "Options", "DefaultGenre", 0)
    strtDir = GetSetting("NightmaresID3Tagger", "Options", "StartDir", App.Path)
    FUp = GetSetting("NightmaresID3Tagger", "Options", "FillUp", "")
    If GetSetting("NightmaresID3Tagger", "Options", "AskReadOnly", "True") = "True" Then
        ROnly = True
    Else
        ROnly = False
    End If
    If GetSetting("NightmaresID3Tagger", "Options", "NextConvert", "True") = "True" Then
        NConv = True
    Else
        NConv = False
    End If
    If GetSetting("NightmaresID3Tagger", "Options", "ShowMp3Error", "False") = "True" Then
        Er = True
    Else
        Er = False
    End If
    If GetSetting("NightmaresID3Tagger", "Options", "ConvertTrackNo", "True") = "True" Then
        CTr = True
    Else
        CTr = False
    End If
    RecS = GetSetting("NightmaresID3Tagger", "Options", "Recognize", "12345")
    ConvTo = GetSetting("NightmaresID3Tagger", "Options", "ConvertTo", 1)
    If GetSetting("NightmaresID3Tagger", "Options", "ConvertUnderscore", "True") = "True" Then
        ConvUS = True
    Else
        ConvUS = False
    End If
    play = GetSetting("NightmaresID3Tagger", "Options", "mp3Player", "")
    iinc = GetSetting("NightmaresID3Tagger", "Options", "InfoInclude", "")
    If GetSetting("NightmaresID3Tagger", "Options", "FillOnlyEmpty", "True") = "True" Then
        fempty = True
    Else
        fempty = False
    End If
    tno = GetSetting("NightmaresID3Tagger", "Options", "TrackNoAtBeginning", 2)
    If GetSetting("NightmaresID3Tagger", "Options", "Lowercase", "True") = "True" Then
        low = True
    Else
        low = False
    End If
End Sub

Public Sub writeOptions()
    SaveSetting "NightmaresID3Tagger", "Options", "genreListName", genListN
    SaveSetting "NightmaresID3Tagger", "Options", "DefaultGenre", defGenre
    SaveSetting "NightmaresID3Tagger", "Options", "StartDir", strtDir
    SaveSetting "NightmaresID3Tagger", "Options", "FillUp", FUp
    If ROnly Then
        SaveSetting "NightmaresID3Tagger", "Options", "AskReadOnly", "True"
    Else
        SaveSetting "NightmaresID3Tagger", "Options", "AskReadOnly", "False"
    End If
    If NConv Then
        SaveSetting "NightmaresID3Tagger", "Options", "NextConvert", "True"
    Else
        SaveSetting "NightmaresID3Tagger", "Options", "NextConvert", "False"
    End If
    If Er Then
        SaveSetting "NightmaresID3Tagger", "Options", "ShowMp3Error", "True"
    Else
        SaveSetting "NightmaresID3Tagger", "Options", "ShowMp3Error", "False"
    End If
    If CTr Then
        SaveSetting "NightmaresID3Tagger", "Options", "ConvertTrackNo", "True"
    Else
        SaveSetting "NightmaresID3Tagger", "Options", "ConvertTrackNo", "False"
    End If
    SaveSetting "NightmaresID3Tagger", "Options", "Recognize", RecS
    SaveSetting "NightmaresID3Tagger", "Options", "ConvertTo", ConvTo
    If ConvUS Then
        SaveSetting "NightmaresID3Tagger", "Options", "ConvertUnderscore", "True"
    Else
        SaveSetting "NightmaresID3Tagger", "Options", "ConvertUnderscore", "False"
    End If
    SaveSetting "NightmaresID3Tagger", "Options", "mp3Player", play
    SaveSetting "NightmaresID3Tagger", "Options", "InfoInclude", iinc
    If fempty Then
        SaveSetting "NightmaresID3Tagger", "Options", "FillOnlyEmpty", "True"
    Else
        SaveSetting "NightmaresID3Tagger", "Options", "FillOnlyEmpty", "False"
    End If
    SaveSetting "NightmaresID3Tagger", "Options", "TrackNoAtBeginning", tno
    If low Then
        SaveSetting "NightmaresID3Tagger", "Options", "Lowercase", "True"
    Else
        SaveSetting "NightmaresID3Tagger", "Options", "Lowercase", "False"
    End If
End Sub
