VERSION 5.00
Begin VB.Form frmID3 
   Caption         =   "ID3 information"
   ClientHeight    =   3120
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5115
   Icon            =   "frmID3.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3120
   ScaleWidth      =   5115
   Begin VB.TextBox txtTrack 
      Height          =   288
      Left            =   4200
      MaxLength       =   3
      TabIndex        =   13
      Top             =   1560
      Width           =   855
   End
   Begin VB.CommandButton cmdConvertTo 
      Caption         =   "C&onvert to filename"
      Height          =   372
      Left            =   2160
      TabIndex        =   18
      ToolTipText     =   "Convert id3 tag to filename"
      Top             =   2640
      Width           =   1812
   End
   Begin VB.TextBox txtTitle 
      Height          =   288
      Left            =   960
      TabIndex        =   1
      Top             =   120
      Width           =   4092
   End
   Begin VB.TextBox txtComment 
      Height          =   288
      Left            =   960
      MaxLength       =   28
      TabIndex        =   11
      Top             =   1560
      Width           =   2295
   End
   Begin VB.TextBox txtAlbum 
      Height          =   288
      Left            =   960
      MaxLength       =   30
      TabIndex        =   5
      Top             =   828
      Width           =   4092
   End
   Begin VB.TextBox txtArtist 
      Height          =   288
      Left            =   960
      TabIndex        =   3
      Top             =   468
      Width           =   4092
   End
   Begin VB.TextBox txtYear 
      Height          =   288
      Left            =   4200
      MaxLength       =   4
      TabIndex        =   9
      Top             =   1188
      Width           =   855
   End
   Begin VB.ComboBox cboGenre 
      Height          =   288
      Left            =   960
      Sorted          =   -1  'True
      Style           =   2  'Dropdown-Liste
      TabIndex        =   7
      Top             =   1190
      Width           =   2292
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Height          =   372
      Left            =   1560
      TabIndex        =   15
      ToolTipText     =   "Save mp3 tag to file(s)"
      Top             =   2040
      Width           =   1332
   End
   Begin VB.CommandButton cmdSaveNext 
      Caption         =   "Save and Next"
      Default         =   -1  'True
      Height          =   372
      Left            =   120
      TabIndex        =   14
      ToolTipText     =   "Save mp3 tag to file(s) and show next"
      Top             =   2040
      Width           =   1332
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "&Next"
      Height          =   372
      Left            =   3000
      TabIndex        =   16
      ToolTipText     =   "Show next file"
      Top             =   2040
      Width           =   1332
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "&Convert from filename"
      Height          =   372
      Left            =   120
      TabIndex        =   17
      ToolTipText     =   "Convert filename to mp3 tag"
      Top             =   2640
      Width           =   1812
   End
   Begin VB.Label lblTrack 
      Caption         =   "T&rack:"
      Height          =   255
      Left            =   3600
      TabIndex        =   12
      Top             =   1590
      Width           =   520
   End
   Begin VB.Label lblArtist 
      Caption         =   "&Artist:"
      Height          =   252
      Left            =   120
      TabIndex        =   2
      Top             =   516
      Width           =   732
   End
   Begin VB.Label lblComment 
      Caption         =   "Co&mment"
      Height          =   252
      Left            =   120
      TabIndex        =   10
      Top             =   1596
      Width           =   732
   End
   Begin VB.Label lblYear 
      Caption         =   "&Year:"
      Height          =   255
      Left            =   3600
      TabIndex        =   8
      Top             =   1230
      Width           =   520
   End
   Begin VB.Label lblGenre 
      Caption         =   "&Genre:"
      Height          =   252
      Left            =   120
      TabIndex        =   6
      Top             =   1236
      Width           =   732
   End
   Begin VB.Label lblTitle 
      Caption         =   "Song &title:"
      Height          =   252
      Left            =   120
      TabIndex        =   0
      Top             =   156
      Width           =   732
   End
   Begin VB.Label lblAlbum 
      Caption         =   "A&lbum:"
      Height          =   252
      Left            =   120
      TabIndex        =   4
      Top             =   876
      Width           =   732
   End
End
Attribute VB_Name = "frmID3"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub prev()
    Dim firstsel As Integer
    Dim count As Integer
    Dim selected As Boolean
    Dim list As Object
    
    If frmFile.filFile.Visible = True Then
        Set list = frmFile.filFile
    Else
        Set list = frmFile.lstRecursFiles
    End If
    firstsel = list.listcount
    selected = False
    frmMain.disableReadId3 = True
    For count = list.listcount - 1 To 0 Step -1
        If list.selected(count) Then
            selected = True
            firstsel = count
            list.selected(count) = False
        End If
    Next count
    frmMain.disableReadId3 = False
    
    If selected = False Then
        list.selected(list.listcount - 1) = True
    ElseIf firstsel > 0 Then
        list.selected(firstsel - 1) = True
    Else
        list.selected(list.listcount - 1) = True
    End If
    
    If txtTitle.Enabled Then
        txtTitle.SetFocus
    End If

End Sub

Private Sub cmdConvert_Click()
    Dim id3 As New ID3Tag
    Dim fn As String
    Dim didWork As Boolean
    Dim count As Integer
    Dim list As Object
    Dim recurs As Boolean
    Dim pn As String
    Dim slashpos As Integer
    Dim opt As New COptions
    Dim filen As String
    
    opt.readOptions
    
    If frmFile.filFile.Visible = True Then
        recurs = False
        Set list = frmFile.filFile
        pn = frmFile.filFile.Path
    Else
        recurs = True
        Set list = frmFile.lstRecursFiles
        pn = Mid(frmFile.lblDir.caption, InStr(1, frmFile.lblDir.caption, " ") + 1)
    End If
    
    Screen.MousePointer = vbHourglass
    'frmProgress.lblProgress.caption = "Converting..."
    'frmProgress.prbProgress.Min = 0
    'frmProgress.prbProgress.max = list.listcount - 1
    'frmProgress.Show
    'frmProgress.Refresh
    
    didWork = False
    For count = 0 To list.listcount - 1
        If list.selected(count) = True Then
            'frmProgress.prbProgress.Value = count
            slashpos = 0
            Do While InStr(slashpos + 1, list.list(count), "\") > 0
                slashpos = InStr(slashpos + 1, list.list(count), "\")
            Loop
            filen = Mid(list.list(count), slashpos + 1)
            If right(pn, 1) = "\" Then
                fn = pn & list.list(count)
            Else
                fn = pn & "\" & list.list(count)
            End If
            id3.Album = txtAlbum.Text
            id3.genre = frmMain.genList.string2num(frmID3.cboGenre.Text)
            id3.Year = txtYear.Text
            id3.Comment = txtComment.Text
            id3.ConvertFilename filen, fn
            id3.writeTag (fn)
            If didWork = True Then
                list.selected(count) = False
            Else
                didWork = True
            End If
        End If
    Next count
    
    If didWork Then
        If recurs = True Then
            frmFile.lstRecursFiles_Click
        Else
            frmFile.filFile_Click
        End If
        If opt.NextConvert Then
            cmdNext_Click
        End If
    End If
    
    'frmProgress.Hide
    Screen.MousePointer = vbDefault
    
End Sub

Private Sub cmdConvertTo_Click()
    Dim id3 As New ID3Tag
    Dim fn As String
    Dim didWork As Boolean
    Dim count As Integer
    Dim list As Object
    Dim recurs As Boolean
    Dim pn As String
    Dim firstnum As Integer
    Dim slashpos As Integer
    Dim opt As New COptions
    
    Const blank30 As String = "                              "
    
    On Error GoTo error
    
    opt.readOptions
    cmdSave_Click
    
    If frmFile.filFile.Visible = True Then
        recurs = False
        Set list = frmFile.filFile
        pn = frmFile.filFile.Path
    Else
        recurs = True
        Set list = frmFile.lstRecursFiles
        pn = Mid(frmFile.lblDir.caption, InStr(1, frmFile.lblDir.caption, " ") + 1)
    End If
    
    If right(pn, 1) <> "\" Then
        pn = pn & "\"
    End If
    
    Screen.MousePointer = vbHourglass
    'frmProgress.lblProgress.caption = "Converting..."
    'frmProgress.prbProgress.Min = 0
    'frmProgress.prbProgress.max = list.listcount - 1
    'frmProgress.Show
    'frmProgress.Refresh
    
    frmMain.disableReadId3 = True
    didWork = False
    For count = 0 To list.listcount - 1
        'frmProgress.prbProgress.Value = count
        If list.selected(count) = True Then
            id3.readTag pn & list.list(count)
            If id3.Artist = blank30 And id3.Title = blank30 Then
                MsgBox "File " & list.list(count) & " does not contain" & _
                    " enough ID3 informations for converting", , "Convert to filename"
                GoTo stepover
            End If
            fn = id3.ConvertToFilename(txtTitle.Text, txtArtist.Text, txtTrack.Text, txtComment.Text)
            
            If recurs And InStr(1, list.list(count), "\") Then
                slashpos = 0
                Do While InStr(slashpos + 1, list.list(count), "\") > 0
                    slashpos = InStr(slashpos + 1, list.list(count), "\")
                Loop
                fn = Left(list.list(count), slashpos) & fn
            End If
                        
            If UCase(list.list(count)) <> UCase(fn) Then
                Name pn & list.list(count) As pn & fn
                If recurs Then
                    list.RemoveItem count
                    list.AddItem fn
                End If
            End If
            
            If didWork = True Then
                If Not recurs Then
                    list.selected(count) = False
                End If
            Else
                didWork = True
                firstnum = count
            End If
            If recurs Then
                count = count - 1
                'because changed item was removed
            End If
        End If
stepover:
    Next count
    frmMain.disableReadId3 = False
    
    If didWork Then
        If recurs = True Then
            frmFile.lstRecursFiles.Refresh
            frmMain.enableID3 False
            frmMain.enableInfo False
            frmFile.lstRecursFiles_Click
        Else
            frmFile.filFile.Refresh
            frmFile.filFile.selected(firstnum) = True
        End If
        If opt.NextConvert Then
            cmdNext_Click
        End If
    End If
        
ending:
    'frmProgress.Hide
    Screen.MousePointer = vbDefault
    Exit Sub

error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Resume ending
        End If
    Case ErrCatFile
        If Err.Number = ErrFileAlreadyExist Then
            MsgBox "File " & list.list(count) & " would be renamed " & _
                        "to an already existing filename. Operation cannot proceed, " & _
                        "please rename by hand.", vbExclamation + vbOKOnly
            Resume stepover
        Else
            Select Case FileError(Err.Number, "Converting", list.list(count))
            Case vbRetry
                Resume
            Case vbCancel
                Resume stepover
            End Select
        End If
    Case Else
        Select Case MiscError(Err.Number, "Writing playlist")
        Case vbRetry
            Resume
        Case vbCancel
            Resume ending
        End Select
    End Select
        
End Sub

Private Sub cmdNext_Click()
    Dim maxsel As Integer
    Dim count As Integer
    Dim selected As Boolean
    Dim list As Object
    
    If frmFile.filFile.Visible = True Then
        Set list = frmFile.filFile
    Else
        Set list = frmFile.lstRecursFiles
    End If
    maxsel = 0
    selected = False
    frmMain.disableReadId3 = True
    For count = 0 To list.listcount - 1
        If list.selected(count) Then
            selected = True
            maxsel = count
            list.selected(count) = False
        End If
    Next count
    frmMain.disableReadId3 = False
    
    If selected = False Then
        list.selected(0) = True
    ElseIf maxsel < list.listcount - 1 Then
        list.selected(maxsel + 1) = True
    Else
        list.selected(0) = True
    End If
    
    If txtTitle.Enabled Then
        txtTitle.SetFocus
    End If
    
End Sub

Private Sub cmdSave_Click()
    Dim id3 As New ID3Tag
    Dim count As Integer
    Dim fn As String
    Dim list As Object
    Dim pn As String
    Dim recurs As Boolean
    Dim tracktemp As Integer
    
    If frmFile.filFile.Visible = True Then
        recurs = False
        Set list = frmFile.filFile
        pn = frmFile.filFile.Path
    Else
        recurs = True
        Set list = frmFile.lstRecursFiles
        pn = Mid(frmFile.lblDir.caption, InStr(1, frmFile.lblDir.caption, " ") + 1)
    End If
    
    Screen.MousePointer = vbHourglass
    'frmProgress.lblProgress.caption = "Writing ID3 tag(s)..."
    'frmProgress.prbProgress.Min = 0
    'frmProgress.prbProgress.max = list.listcount - 1
    'frmProgress.Show
    'frmProgress.Refresh
    
    For count = 0 To list.listcount - 1
        'frmProgress.prbProgress.Value = count
        If list.selected(count) Then
            If right(pn, 1) = "\" Then
                fn = pn & list.list(count)
            Else
                fn = pn & "\" & list.list(count)
            End If
            id3.readTag fn
            If (frmID3.txtTitle.Text <> "") Then
                id3.Title = frmID3.txtTitle.Text
            End If
            If (frmID3.txtArtist.Text <> "") Then
                id3.Artist = frmID3.txtArtist.Text
            End If
            If (frmID3.txtAlbum.Text <> "") Then
                id3.Album = frmID3.txtAlbum.Text
            End If
            If (frmID3.txtComment.Text <> "") Then
                id3.Comment = frmID3.txtComment.Text
            End If
            If (frmID3.txtYear.Text <> "") Then
                id3.Year = frmID3.txtYear.Text
            End If
            If (frmID3.cboGenre.ListIndex <> 0) Then
                id3.genre = frmMain.genList.string2num(frmID3.cboGenre.Text)
            End If
            If (frmID3.txtTrack.Text <> "") Then
                If IsNumeric(frmID3.txtTrack.Text) Then
                    tracktemp = CInt(frmID3.txtTrack.Text)
                    If tracktemp > -1 And tracktemp < 256 Then
                        id3.track = CByte(frmID3.txtTrack.Text)
                    Else
                        id3.track = 0
                    End If
                Else
                    id3.track = 0
                End If
            End If
            id3.writeTag fn
        End If
    Next count
    
    'frmProgress.Hide
    Screen.MousePointer = vbDefault
End Sub

Private Sub cmdSaveNext_Click()
    cmdSave_Click
    cmdNext_Click
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim ShiftDown, AltDown, CtrlDown, txt As Boolean
    Dim i As Integer
    ShiftDown = (Shift And vbShiftMask) > 0
    AltDown = (Shift And vbAltMask) > 0
    CtrlDown = (Shift And vbCtrlMask) > 0
    
    If Not CtrlDown And Not ShiftDown And Not AltDown And KeyCode = vbKeyDown Then
        cmdNext_Click
        KeyCode = 0
    ElseIf Not CtrlDown And Not ShiftDown And Not AltDown And KeyCode = vbKeyUp Then
        prev
        KeyCode = 0
    ElseIf CtrlDown And Not ShiftDown And Not AltDown And KeyCode = vbKeyP Then
        frmFile.runMp3Player
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode <> vbFormMDIForm Then
        'close only when MDI form closes
        WindowState = vbMinimized
        Cancel = 1
    End If
End Sub

Private Sub Form_Resize()
    
    If WindowState <> vbNormal Then
        Exit Sub
    End If
    
    If Height < 3480 Then
        Height = 3480
    End If
    If Width < 4470 Then
        Width = 4470
    End If
    
    lblTitle.Left = 120
    lblTitle.Top = 156
    
    txtTitle.Left = 960
    txtTitle.Top = 120
    txtTitle.Width = Width - 1080
    
    lblArtist.Left = 120
    lblArtist.Top = 516
    
    txtArtist.Left = 960
    txtArtist.Top = 468
    txtArtist.Width = Width - 1080
    
    lblAlbum.Left = 120
    lblAlbum.Top = 876
    
    txtAlbum.Left = 960
    txtAlbum.Top = 828
    txtAlbum.Width = Width - 1080
    
    lblGenre.Left = 120
    lblGenre.Top = 1236
    
    cboGenre.Left = 960
    cboGenre.Top = 1190
    cboGenre.Width = Width / 2
    
    lblYear.Left = 1080 + cboGenre.Width
    lblYear.Top = 1236
    
    txtYear.Left = lblYear.Left + lblYear.Width
    txtYear.Top = 1188
    txtYear.Width = Width - txtYear.Left - 120
    
    lblComment.Left = 120
    lblComment.Top = 1596
    
    txtComment.Left = 960
    txtComment.Top = 1548
    txtComment.Width = Width / 2
    
    lblTrack.Left = 1080 + txtComment.Width
    lblTrack.Top = 1596
    
    txtTrack.Left = lblYear.Left + lblYear.Width
    txtTrack.Top = 1548
    txtTrack.Width = Width - txtYear.Left - 120
    
    cmdSaveNext.Left = 120
    cmdSaveNext.Top = txtComment.Top + txtComment.Height + 220
    
    cmdSave.Left = 1560
    cmdSave.Top = cmdSaveNext.Top
    
    cmdNext.Left = 3000
    cmdNext.Top = cmdSaveNext.Top
    
    cmdConvert.Left = 120
    cmdConvert.Top = cmdSaveNext.Top + cmdSaveNext.Height + 200
    
    cmdConvertTo.Left = 2160
    cmdConvertTo.Top = cmdConvert.Top
    
End Sub

Private Sub txtArtist_KeyUp(KeyCode As Integer, Shift As Integer)
    If Len(txtArtist.Text) > 30 Then
        txtArtist.ForeColor = vbRed
    Else
        txtArtist.ForeColor = vbBlack
    End If
End Sub

Private Sub txtTitle_GotFocus()
    txtTitle.SelStart = 0
    txtTitle.SelLength = Len(txtTitle.Text)
End Sub

Private Sub txtArtist_GotFocus()
    txtArtist.SelStart = 0
    txtArtist.SelLength = Len(txtArtist.Text)
End Sub

Private Sub txtAlbum_GotFocus()
    txtAlbum.SelStart = 0
    txtAlbum.SelLength = Len(txtAlbum.Text)
End Sub

Private Sub txtComment_GotFocus()
    txtComment.SelStart = 0
    txtComment.SelLength = Len(txtComment.Text)
End Sub

Private Sub txtTrack_GotFocus()
    txtTrack.SelStart = 0
    txtTrack.SelLength = Len(txtTrack.Text)
End Sub

Private Sub txtTitle_KeyUp(KeyCode As Integer, Shift As Integer)
    If Len(txtTitle.Text) > 30 Then
        txtTitle.ForeColor = vbRed
    Else
        txtTitle.ForeColor = vbBlack
    End If
End Sub

Private Sub txtYear_GotFocus()
    txtYear.SelStart = 0
    txtYear.SelLength = Len(txtYear.Text)
End Sub
