VERSION 5.00
Begin VB.Form frmInfo 
   Caption         =   "File information"
   ClientHeight    =   1575
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5085
   Icon            =   "frmInfo.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   1575
   ScaleWidth      =   5085
   Begin VB.TextBox txtFileName 
      BackColor       =   &H00C0C0C0&
      Height          =   288
      Left            =   1080
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "aaa"
      Top             =   80
      Width           =   3972
   End
   Begin VB.Label lblFileSize 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "aaa"
      Height          =   252
      Left            =   1080
      TabIndex        =   7
      Top             =   460
      Width           =   1452
   End
   Begin VB.Label lblFileNameInfo 
      Caption         =   "File name:"
      Height          =   252
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   852
   End
   Begin VB.Label lblFileSizeInfo 
      Caption         =   "File size:"
      Height          =   252
      Left            =   120
      TabIndex        =   9
      Top             =   480
      Width           =   852
   End
   Begin VB.Label lblFileLengthinfo 
      Caption         =   "Length:"
      Height          =   252
      Left            =   2640
      TabIndex        =   8
      Top             =   480
      Width           =   612
   End
   Begin VB.Label lblFileLength 
      BorderStyle     =   1  'Fixed Single
      Height          =   252
      Left            =   3240
      TabIndex        =   6
      Top             =   480
      Width           =   1692
   End
   Begin VB.Label lblBitrateInfo 
      Caption         =   "Bitrate:"
      Height          =   252
      Left            =   120
      TabIndex        =   5
      Top             =   840
      Width           =   492
   End
   Begin VB.Label lblBitrate 
      BorderStyle     =   1  'Fixed Single
      Height          =   252
      Left            =   1080
      TabIndex        =   4
      Top             =   840
      Width           =   3972
   End
   Begin VB.Label lblSampleInfo 
      Caption         =   "Sample rate:"
      Height          =   252
      Left            =   120
      TabIndex        =   3
      Top             =   1200
      Width           =   972
   End
   Begin VB.Label lblSample 
      BorderStyle     =   1  'Fixed Single
      Height          =   252
      Left            =   1080
      TabIndex        =   2
      Top             =   1200
      Width           =   1332
   End
   Begin VB.Label lblFileNameTooLong 
      Caption         =   "Filename too long!"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   252
      Left            =   2640
      TabIndex        =   1
      Top             =   1200
      Width           =   1692
   End
End
Attribute VB_Name = "frmInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim ShiftDown, AltDown, CtrlDown, txt As Boolean
    Dim i As Integer
    ShiftDown = (Shift And vbShiftMask) > 0
    AltDown = (Shift And vbAltMask) > 0
    CtrlDown = (Shift And vbCtrlMask) > 0
    
    If CtrlDown And Not ShiftDown And Not AltDown And KeyCode = vbKeyP Then
        frmFile.runMp3Player
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode <> vbFormMDIForm Then
        'close only when MDI form closes
        WindowState = vbMinimized
        Cancel = 1
    End If
End Sub

Private Sub Form_Resize()
    Const maxDist = 110
    Dim vertDist As Integer
    
    If WindowState <> vbNormal Then
        Exit Sub
    End If
    
    If Height < 1620 Then
        Height = 1620
    End If
    If Width < 3850 Then
        Width = 3850
    End If
    
    vertDist = ((ScaleHeight - 120) / 4) - lblFileNameInfo.Height
    If vertDist > maxDist Then
        vertDist = maxDist
    End If
    
    lblFileNameInfo.Left = 120
    lblFileNameInfo.Top = 120
    
    txtFileName.Left = 1080
    txtFileName.Top = 80
    txtFileName.Width = ScaleWidth - 1200
    
    lblFileSizeInfo.Left = 120
    lblFileSizeInfo.Top = lblFileNameInfo.Top + lblFileNameInfo.Height + vertDist
    
    lblFileSize.Left = 1080
    lblFileSize.Top = lblFileSizeInfo.Top - 20
    lblFileSize.Width = (ScaleWidth - lblFileLengthinfo.Width - 1320) / 2
    
    lblFileLengthinfo.Left = lblFileSize.Width + 1200
    lblFileLengthinfo.Top = lblFileSizeInfo.Top

    lblFileLength.Left = lblFileLengthinfo.Left + lblFileLengthinfo.Width
    lblFileLength.Top = lblFileSize.Top
    lblFileLength.Width = ScaleWidth - lblFileLength.Left - 120
    
    lblBitrateInfo.Left = 120
    lblBitrateInfo.Top = lblFileSizeInfo.Top + lblFileSizeInfo.Height + vertDist
    
    lblBitrate.Left = 1080
    lblBitrate.Top = lblBitrateInfo.Top - 20
    lblBitrate.Width = ScaleWidth - 1200
    
    lblSampleInfo.Left = 120
    lblSampleInfo.Top = lblBitrateInfo.Top + lblBitrateInfo.Height + vertDist
    
    lblSample.Left = 1080
    lblSample.Top = lblSampleInfo.Top - 20
    lblSample.Width = lblFileLength.Width
    
    lblFileNameTooLong.Left = 1200 + lblSample.Width
    lblFileNameTooLong.Top = lblSampleInfo.Top

End Sub

Public Function sec2minsec(ByVal sec As Long) As String
    Dim h As Long
    Dim m As Long
    Dim s As Long
    Dim mstr As String
    Dim sstr As String
    Dim temp As Long
    
    h = Int(sec / 3600)
    sec = sec - (h * 3600)
    m = Int(sec / 60)
    s = sec Mod 60
    mstr = CStr(m)
    If Len(mstr) = 1 Then
        mstr = "0" & mstr
    End If
    sstr = CStr(s)
    If Len(sstr) = 1 Then
        sstr = "0" & sstr
    End If
    If h > 0 Then
        sec2minsec = CStr(h) & ":" & mstr & ":" & sstr
    Else
        sec2minsec = CStr(m) & ":" & sstr
    End If
End Function

