VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.MDIForm frmMain 
   AutoShowChildren=   0   'False
   BackColor       =   &H8000000C&
   Caption         =   "Nightmare's ID3 Tagger"
   ClientHeight    =   5475
   ClientLeft      =   135
   ClientTop       =   420
   ClientWidth     =   7050
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   2  'Bildschirmmitte
   WindowState     =   2  'Maximiert
   Begin MSComDlg.CommonDialog cdlHelp 
      Left            =   2640
      Top             =   1200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      HelpCommand     =   3
      HelpContext     =   10
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileRefresh 
         Caption         =   "&Refresh"
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuFileExport 
         Caption         =   "&Export..."
         Shortcut        =   ^E
      End
      Begin VB.Menu mnuFileDiv2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditRecurs 
         Caption         =   "&Recursive mode..."
         Shortcut        =   ^R
      End
      Begin VB.Menu mnuEditDiv1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditOptions 
         Caption         =   "&Options..."
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
      WindowList      =   -1  'True
      Begin VB.Menu mnuWindowOpt 
         Caption         =   "Arrange &optimal"
      End
      Begin VB.Menu mnuWindowDiv1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuWindowHori 
         Caption         =   "Tile &horizontally"
      End
      Begin VB.Menu mnuWindowVert 
         Caption         =   "Tile &vertically"
      End
      Begin VB.Menu mnuWindowCascade 
         Caption         =   "&Cascade"
      End
      Begin VB.Menu mnuWindowIcons 
         Caption         =   "&Arrange icons"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpContents 
         Caption         =   "Contents"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "About..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public genList As New CGenreList
Public Options As New COptions
Public disableReadId3 As Boolean

Public Sub init()

    On Error GoTo error

    If right(App.Path, 1) = "\" Then
        App.HelpFile = App.Path & "id3tagger.hlp"
        cdlHelp.HelpFile = App.Path & "id3tagger.hlp"
    Else
        App.HelpFile = App.Path & "\id3tagger.hlp"
        cdlHelp.HelpFile = App.Path & "\id3tagger.hlp"
    End If
    frmInfo.Show
    frmID3.Show
    frmFile.Show
    disableReadId3 = False
    Options.readOptions
    fillGenList
    frmFile.drvDrive.Drive = Left(Options.startDir, 1)
    frmFile.dirDir.Path = Options.startDir
resumehere:
    enableID3 False
    enableInfo False
    resizeOpt
    Exit Sub

error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatFile
        MsgBox "Cannot change to startup directory. Using c:\ instead. Plase set directory with Edit | Options.", vbOKOnly, "Starting up"
        Resume resumehere
    Case Else
        Select Case MiscError(Err.Number, "Starting program")
        Case vbRetry
            Resume
        Case vbCancel
            Resume resumehere
        End Select
    End Select
End Sub

Public Sub fillGenList()
    Dim count As Byte
    Dim genre As String

    genList.read Options.genListName
    frmID3.cboGenre.AddItem ""
    count = 0
    Do
        genre = genList.num2string(count)
        If genre <> "" Then
            frmID3.cboGenre.AddItem genre
            count = count + 1
        Else
            Exit Do
        End If
    Loop
        
End Sub

Public Sub resizeOpt()
    
    If frmFile.WindowState = vbNormal Then
        frmFile.Top = 0
        frmFile.Left = 0
        frmFile.Width = frmMain.ScaleWidth / 3
        frmFile.Height = frmMain.ScaleHeight
    End If
    
    If frmID3.WindowState = vbNormal Then
        frmID3.Top = 0
        frmID3.Left = frmFile.Width + 1
        frmID3.Width = frmMain.ScaleWidth - frmFile.Width
        frmID3.Height = frmMain.ScaleHeight * 0.66
    End If
    
    If frmInfo.WindowState = vbNormal Then
        frmInfo.Top = frmID3.Height + 1
        frmInfo.Left = frmFile.Width + 1
        frmInfo.Width = frmMain.ScaleWidth - frmFile.Width
        frmInfo.Height = frmMain.ScaleHeight - frmID3.Height
    End If
    
End Sub

Public Sub enableID3(ByVal able As Boolean)
    frmID3.txtTitle.Enabled = able
    frmID3.txtTitle.Text = ""
    frmID3.txtTitle.ForeColor = vbBlack
    frmID3.lblTitle.Enabled = able
    frmID3.txtArtist.Enabled = able
    frmID3.txtArtist.Text = ""
    frmID3.txtArtist.ForeColor = vbBlack
    frmID3.lblArtist.Enabled = able
    frmID3.txtAlbum.Enabled = able
    frmID3.txtAlbum.Text = ""
    frmID3.lblAlbum.Enabled = able
    frmID3.txtComment.Enabled = able
    frmID3.txtComment.Text = ""
    frmID3.lblComment.Enabled = able
    frmID3.txtYear.Enabled = able
    frmID3.txtYear.Text = ""
    frmID3.lblYear.Enabled = able
    frmID3.lblTrack.Enabled = able
    frmID3.txtTrack.Enabled = able
    frmID3.cboGenre.Enabled = able
    frmID3.lblGenre.Enabled = able
    frmID3.cmdSaveNext.Enabled = able
    frmID3.cmdSave.Enabled = able
    frmID3.cmdNext.Enabled = able
    frmID3.cmdConvert.Enabled = able
    frmID3.cmdConvertTo.Enabled = able
    
End Sub

Public Sub enableInfo(ByVal able As Boolean)
    frmInfo.lblFileNameInfo.Enabled = able
    frmInfo.txtFileName.Enabled = able
    frmInfo.txtFileName.Text = ""
    frmInfo.lblFileSizeInfo.Enabled = able
    frmInfo.lblFileSize.Enabled = able
    frmInfo.lblFileSize.caption = ""
    frmInfo.lblFileLengthinfo.Enabled = able
    frmInfo.lblFileLength.Enabled = able
    frmInfo.lblFileLength.caption = ""
    frmInfo.lblBitrateInfo.Enabled = able
    frmInfo.lblBitrate.Enabled = able
    frmInfo.lblBitrate.caption = ""
    frmInfo.lblSampleInfo.Enabled = able
    frmInfo.lblSample.Enabled = able
    frmInfo.lblSample.caption = ""
    If Not able Then
        frmInfo.lblFileNameTooLong.Visible = False
    End If
End Sub

Public Sub DisplayMarkedFiles()
    Dim commonId3 As New ID3Tag
    Dim newId3 As New ID3Tag
    Dim firstId3 As Boolean
    Dim blank30 As String * 30
    Dim count As Integer
    Dim onlyOne As Boolean
    Dim fn As String
    Dim recurs As Boolean
    Dim listcount As Integer
    Dim list As Object
    Dim pn As String
    Dim selected As Boolean
    Dim length As Long
    Dim bitrate As Integer
    Dim sample As Single
    Dim mono As Integer
    Dim typ As Integer
    Dim size As Long
    Dim vbr As Boolean
    
    On Error GoTo error
    
    blank30 = String(30, " ")
    
    selected = False
    firstId3 = True
    onlyOne = True
    commonId3.Reset
    newId3.Reset
    
    If frmFile.filFile.Visible = True Then
        recurs = False
        Set list = frmFile.filFile
        pn = frmFile.filFile.Path
    Else
        recurs = True
        Set list = frmFile.lstRecursFiles
        pn = Mid(frmFile.lblDir.caption, InStr(1, frmFile.lblDir.caption, " ") + 1)
    End If
    
    'If list.ListIndex > -1 Then
    '    Screen.MousePointer = vbHourglass
    '    frmProgress.lblProgress.caption = "Reading ID3 tag(s)..."
    '    frmProgress.prbProgress.Min = 0
    '    frmProgress.prbProgress.max = list.listcount - 1
    '    frmProgress.Show
    '    frmProgress.Refresh
    'End If
    
    For count = 0 To list.listcount - 1
    '    frmProgress.prbProgress.Value = count
        If list.selected(count) Then
            selected = True
            If right(pn, 1) = "\" Then
                fn = pn & list.list(count)
            Else
                fn = pn & "\" & list.list(count)
            End If
            newId3.readTag fn
            If firstId3 = True Then
                'first id3 read
                commonId3.Title = newId3.Title
                commonId3.Artist = newId3.Artist
                commonId3.Album = newId3.Album
                commonId3.Comment = newId3.Comment
                commonId3.Year = newId3.Year
                commonId3.genre = newId3.genre
                commonId3.track = newId3.track
                length = newId3.length
                bitrate = newId3.bitrate
                sample = newId3.sample
                mono = newId3.mono
                typ = newId3.typ
                firstId3 = False
                size = FileLen(fn)
                vbr = newId3.vbr
            Else
                onlyOne = False
                If (commonId3.Title <> newId3.Title) Then
                    commonId3.Title = blank30
                End If
                If (commonId3.Artist <> newId3.Artist) Then
                    commonId3.Artist = blank30
                End If
                If commonId3.Album <> newId3.Album Then
                    commonId3.Album = blank30
                End If
                If commonId3.Comment <> newId3.Comment Then
                    commonId3.Comment = blank30
                End If
                If commonId3.Year <> newId3.Year Then
                    commonId3.Year = blank30
                End If
                If commonId3.genre <> newId3.genre Then
                    commonId3.genre = 255
                End If
                If commonId3.track <> newId3.track Then
                    commonId3.track = 0
                End If
                If newId3.length > -1 And length <> -2 Then
                    length = length + newId3.length
                End If
                If sample <> newId3.sample Then
                    sample = -1
                End If
                If bitrate <> newId3.bitrate Then
                    bitrate = -1
                End If
                If mono <> newId3.mono Then
                    mono = -1
                End If
                If typ <> newId3.typ Then
                    typ = -1
                End If
                If size <> -2 Then
                    size = size + FileLen(fn)
                End If
                If vbr <> newId3.vbr Then
                    vbr = False
                End If
            End If
        End If
nextfor:
    Next count
    
    If selected = True Then
        enableID3 True
        enableInfo True
        displayID3 commonId3
        displayInfo fn, length, bitrate, sample, mono, typ, size, vbr
    Else
        enableID3 False
        enableInfo False
    End If
    
    'frmProgress.Visible = False
    'Screen.MousePointer = vbDefault
    Exit Sub

error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Exit Sub
        Else
            Select Case MiscError(Err.Number, "Reading file info")
            Case vbRetry
                Resume
            Case vbCancel
                Resume nextfor
            End Select
        End If
    Case ErrCatFile
        Select Case FileError(Err.Number, "Reading file info", fn)
        Case vbRetry
            Resume
        Case vbCancel
            Resume nextfor
        End Select
    Case Else
        If Err.Number = 5 Then
            Select Case MsgBox("File access error.", vbRetryCancel, "Reading file info")
            Case vbRetry
                Resume
            Case vbCancel
                Resume nextfor
            End Select
        ElseIf Err.Number = ErrOverFlow Then
            size = -2
            length = -2
            Resume Next
        Else
            Select Case MiscError(Err.Number, "Reading file info")
            Case vbRetry
                Resume
            Case vbCancel
                Resume nextfor
            End Select
        End If
    End Select
    
End Sub

Public Sub displayID3(ByVal id3 As ID3Tag)
    
    frmID3.txtTitle.Text = id3.killSpace(id3.Title)
    frmID3.txtArtist.Text = id3.killSpace(id3.Artist)
    frmID3.txtAlbum.Text = id3.killSpace(id3.Album)
    frmID3.txtComment.Text = id3.killSpace(id3.Comment)
    frmID3.txtYear.Text = id3.killSpace(id3.Year)
    If id3.track > 0 Then
        frmID3.txtTrack.Text = id3.track
    Else
        frmID3.txtTrack.Text = ""
    End If
    showGenre id3.genre
    
End Sub

Public Sub displayInfo(ByVal fn As String, ByVal length As Long, _
                       ByVal bitrate As Single, ByVal sample As String, _
                       ByVal mono As Integer, ByVal typ As Integer, _
                       size As Long, vbr As Boolean)

    Dim mstr As String
    Dim slashpos As Integer
    Dim compressed As Boolean

    On Error GoTo error

    frmInfo.txtFileName.Locked = False
    frmInfo.txtFileName.Text = fn
    frmInfo.txtFileName.SelStart = Len(frmInfo.txtFileName.Text)
    frmInfo.txtFileName.SelLength = 0
    frmInfo.txtFileName.Locked = True
    If size <> -2 Then
        frmInfo.lblFileSize.caption = size & " bytes"
    End If
    If length >= -2 Then
        frmInfo.lblFileLength.caption = frmInfo.sec2minsec(length)
    Else
        frmInfo.lblFileLength.caption = ""
    End If
    If mono = 0 Then
        mstr = "(Mono)"
    ElseIf mono = 1 Then
        mstr = "(Stereo)"
    Else
        mstr = ""
    End If
    If bitrate <> -1 Then
        frmInfo.lblBitrate.caption = bitrate & " kbit/s" & " " & mstr
    Else
        frmInfo.lblBitrate = ""
    End If
    If typ >= 128 Then
        compressed = True
        typ = typ - 128
    Else
        compressed = False
    End If
    Select Case typ
    Case 0
        frmInfo.lblBitrate.caption = frmInfo.lblBitrate.caption & " (Illegal type"
    Case 1
        frmInfo.lblBitrate.caption = frmInfo.lblBitrate.caption & " (Type 1"
    Case 2
        frmInfo.lblBitrate.caption = frmInfo.lblBitrate.caption & " (Type 2"
    Case 2.5
        frmInfo.lblBitrate.caption = frmInfo.lblBitrate.caption & " (Type 2.5"
    End Select
    If compressed Then
        frmInfo.lblBitrate.caption = frmInfo.lblBitrate.caption & ", Compressed WAV"
    End If
    If vbr Then
        frmInfo.lblBitrate.caption = frmInfo.lblBitrate.caption & ", VBR"
    End If
    
    If typ <> -1 Then
        frmInfo.lblBitrate.caption = frmInfo.lblBitrate.caption & ")"
    End If

    If sample <> -1 Then
        frmInfo.lblSample.caption = sample & " kHz"
    Else
        frmInfo.lblSample.caption = ""
    End If
    slashpos = 0
    Do While InStr(slashpos + 1, fn, "\")
        slashpos = InStr(slashpos + 1, fn, "\")
    Loop
    If Len(Mid(fn, slashpos + 1)) > 60 Then
        frmInfo.lblFileNameTooLong.Visible = True
        Beep
    Else
        frmInfo.lblFileNameTooLong.Visible = False
    End If
    
    Exit Sub

error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Exit Sub
        Else
            If Err.Number = 5 Then
                Select Case MsgBox("File access error.", vbRetryCancel, "Reading file info")
                Case vbRetry
                    Resume
                Case vbCancel
                    Exit Sub
                End Select
            Else
                Select Case MiscError(Err.Number, "Reading file info")
                Case vbRetry
                    Resume
                Case vbCancel
                    Exit Sub
                End Select
            End If
        End If
    Case ErrCatFile
        Select Case FileError(Err.Number, "Reading file info", fn)
        Case vbRetry
            Resume
        Case vbCancel
            Exit Sub
        End Select
    Case Else
        If Err.Number = 5 Then
            Select Case MsgBox("File access error.", vbRetryCancel, "Reading file info")
            Case vbRetry
                Resume
            Case vbCancel
                Exit Sub
            End Select
        Else
            Select Case MiscError(Err.Number, "Reading file info")
            Case vbRetry
                Resume
            Case vbCancel
                Exit Sub
            End Select
        End If
    End Select
End Sub

Private Sub showGenre(ByVal genre As Byte)
    Dim genstr As String
    Dim i As Integer
    
    If genre = 255 Then
        'undefined genre
        frmID3.cboGenre.ListIndex = 0
    End If
    genstr = genList.num2string(genre)
    For i = 0 To frmID3.cboGenre.listcount
        If frmID3.cboGenre.list(i) = genstr Then
            frmID3.cboGenre.ListIndex = i
            Exit For
        End If
    Next i
End Sub

Private Sub recurseDir(ByVal base As String, ByVal pn As String)
    Dim dircount As Integer
    Dim name As String
    Dim fn As String
    Dim dirarr() As String
    Dim d As Variant
    
    On Error GoTo error
    
    dircount = 0
    If right(pn, 1) <> "\" Then
        pn = pn & "\"
    End If
    If right(base, 1) <> "\" Then
        base = base & "\"
    End If
    
    name = Dir(pn, vbDirectory)
    Do While name <> ""
        If right(pn, 1) <> "\" Then
            fn = pn & "\" & name
        Else
            fn = pn & name
        End If
        If name <> "." And name <> ".." Then
            If (GetAttr(fn) And vbDirectory) = vbDirectory Then
                ReDim Preserve dirarr(0 To dircount)
                dirarr(dircount) = fn
                dircount = dircount + 1
            ElseIf right(name, 4) = ".mp3" Then
                frmFile.lstRecursFiles.AddItem (Mid(fn, Len(base) + 1))
            End If
        End If
        name = Dir
    Loop
    
    If dircount > 0 Then
        For Each d In dirarr
            recurseDir base, d
        Next
    End If
    
    Exit Sub

error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Exit Sub
        Else
            Select Case MiscError(Err.Number, "Recursive mode")
            Case vbRetry
                Resume
            Case vbCancel
                Exit Sub
            End Select
        End If
    Case ErrCatFile
        Select Case FileError(Err.Number, "Recursive mode")
        Case vbRetry
            Resume
        Case vbCancel
            Exit Sub
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Recursive mode")
        Case vbRetry
            Resume
        Case vbCancel
            Exit Sub
        End Select
    End Select
        
End Sub

Private Sub showAppHelp()
    cdlHelp.ShowHelp
End Sub

Private Sub MDIForm_Load()
    init
End Sub

Private Sub mnuEditOptions_Click()
    frmOptions.Show 1, Me
    Options.readOptions
End Sub

Private Sub mnuEditRecurs_Click()
    
    On Error GoTo error
    
    If frmMain.mnuEditRecurs.Checked Then
        frmFile.dirDir.Refresh
        frmFile.filFile.Refresh
        frmMain.mnuEditRecurs.Checked = False
        frmFile.lblRecurs_Click
        Exit Sub
    Else
        frmMain.mnuEditRecurs.Checked = True
    End If
    
    tag = ""
    frmSelectDir.drvDrive.Drive = frmFile.drvDrive.Drive
    frmSelectDir.dirDir.Path = frmFile.dirDir.Path
    frmSelectDir.Show 1, Me
    
    If tag <> "" Then
        Screen.MousePointer = vbHourglass
        frmFile.lblDrive.Enabled = False
        frmFile.drvDrive.Enabled = False
        frmFile.dirDir.Visible = False
        frmFile.lblRecurs.Visible = True
        frmFile.filFile.Visible = False
        frmFile.lstRecursFiles.Visible = True
    
        Dim pn As String
        pn = tag
        frmFile.lstRecursFiles.Clear
    
        recurseDir pn, pn
    
        frmFile.lblDir.caption = "Directory: " & pn
        Screen.MousePointer = vbDefault
    Else
        mnuEditRecurs.Checked = False
    End If
    Exit Sub
    
error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatFile
        Select Case FileError(Err.Number, "Entering recursive mode", pn)
        Case vbRetry
            Resume
        Case vbCancel
            mnuEditRecurs.Checked = False
            Exit Sub
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Entering recursive mode")
        Case vbRetry
            Resume
        Case vbCancel
            mnuEditRecurs.Checked = False
            Exit Sub
        End Select
    End Select
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuFileExport_Click()
    Dim num As Integer
    Dim i As Integer
    Dim list As Object
    
    num = 0
    If frmFile.filFile.Visible = True Then
        Set list = frmFile.filFile
    Else
        Set list = frmFile.lstRecursFiles
    End If
    For i = 0 To list.listcount - 1
        If list.selected(i) Then
            num = num + 1
        End If
    Next i
    frmExport.numSel = num
    frmExport.Top = 0
    frmExport.Show 1, frmMain
End Sub

Private Sub mnuFileRefresh_Click()
    On Error GoTo error
    
    If frmFile.filFile.Visible Then
        frmFile.filFile.Refresh
        frmFile.dirDir.Refresh
    Else
        Screen.MousePointer = vbHourglass
        frmFile.lstRecursFiles.Clear
        Dim pn As String
        pn = Mid(frmFile.lblDir.caption, InStr(1, frmFile.lblDir.caption, " ") + 1)
        recurseDir pn, pn
        Screen.MousePointer = vbDefault
    End If
    Exit Sub
    
error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatFile
        Select Case FileError(Err.Number, "Refresh")
        Case vbRetry
            Resume
        Case vbCancel
            Exit Sub
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Refresh")
        Case vbRetry
            Resume
        Case vbCancel
            Exit Sub
        End Select
    End Select
End Sub

Private Sub mnuHelpAbout_Click()
    frmAbout.Show 1, Me
End Sub

Private Sub mnuHelpContents_Click()
    showAppHelp
End Sub

Private Sub mnuWindowCascade_Click()
    frmMain.Arrange vbCascade
End Sub

Private Sub mnuWindowHori_Click()
    frmMain.Arrange vbTileHorizontal
End Sub

Private Sub mnuWindowIcons_Click()
    frmMain.Arrange vbArrangeIcons
End Sub

Private Sub mnuWindowVert_click()
    frmMain.Arrange vbTileVertical
End Sub

Private Sub mnuWindowOpt_Click()
    resizeOpt
End Sub
