VERSION 5.00
Begin VB.Form frmFile 
   Caption         =   "Files"
   ClientHeight    =   5955
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3870
   Icon            =   "frmFile.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   5955
   ScaleWidth      =   3870
   Begin VB.DriveListBox drvDrive 
      Height          =   288
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "Choose drive containing the mp3 files"
      Top             =   360
      Width           =   3612
   End
   Begin VB.DirListBox dirDir 
      Height          =   1584
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "Choose directory containing the mp3 files"
      Top             =   1080
      Width           =   3612
   End
   Begin VB.FileListBox filFile 
      Height          =   2625
      Left            =   120
      MultiSelect     =   2  'Erweitert
      Pattern         =   "*.mp3"
      TabIndex        =   6
      ToolTipText     =   "Choose mp3 file(s)"
      Top             =   3120
      Width           =   3612
   End
   Begin VB.ListBox lstRecursFiles 
      Height          =   2595
      Left            =   120
      MultiSelect     =   2  'Erweitert
      Sorted          =   -1  'True
      TabIndex        =   7
      ToolTipText     =   "Choose mp3 file(s)"
      Top             =   3120
      Visible         =   0   'False
      Width           =   3612
   End
   Begin VB.Label lblRecurs 
      Alignment       =   2  'Zentriert
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "Click here to exit recursive mode"
      Height          =   1572
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Visible         =   0   'False
      Width           =   3612
   End
   Begin VB.Label lblDir 
      AutoSize        =   -1  'True
      Caption         =   "&Directory:"
      Height          =   192
      Left            =   120
      TabIndex        =   2
      Top             =   840
      Width           =   684
   End
   Begin VB.Label lblDrive 
      Caption         =   "D&rive:"
      Height          =   252
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   492
   End
   Begin VB.Label lblFile 
      Caption         =   "&File:"
      Height          =   252
      Left            =   120
      TabIndex        =   5
      Top             =   2880
      Width           =   972
   End
End
Attribute VB_Name = "frmFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Sub runMp3Player()
    Dim opt As New COptions
    
    opt.readOptions
    If opt.mp3Player <> "" Then
        Dim count As Integer
        Dim list As Object
        Dim fn As String
        Dim pn As String
        fn = ""
        If filFile.Visible = True Then
            Set list = filFile
            pn = filFile.Path
        Else
            Set list = lstRecursFiles
            pn = Mid(lblDir.caption, InStr(1, lblDir.caption, " ") + 1)
        End If
        If right(pn, 1) <> "\" Then
            pn = pn & "\"
        End If
        For count = 0 To list.listcount - 1
            If list.selected(count) Then
                fn = pn & list.list(count)
                Exit For
            End If
        Next
        If fn <> "" Then
            If Shell(opt.mp3Player & " " & Chr(34) & fn & Chr(34), vbNormalNoFocus) = 0 Then
                MsgBox "Cannot run MP3 player " & opt.mp3Player & ".", , "Run MP3 player"
            End If
        End If
    End If
End Sub

Private Sub dirDir_Change()
    filFile.Path = dirDir.Path
    frmMain.enableID3 False
    frmMain.enableInfo False
End Sub

Private Sub dirDir_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
    'return
        KeyAscii = 0
        dirDir.Path = dirDir.list(dirDir.ListIndex)
    End If
End Sub

Private Sub drvDrive_Change()
    
    Dim drvtxt As String
    Dim drvletter As String
    Static oldDrv As String
    
    On Error GoTo error
    
    drvtxt = drvDrive.Drive
    drvletter = Left(drvtxt, 2)
    dirDir.Path = drvletter & "\"
    oldDrv = drvletter

    Exit Sub
error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Exit Sub
        End If
    Case ErrCatFile
        Select Case FileError(Err.Number, "Changing drive")
        Case vbRetry
            Resume
        Case vbCancel
            If oldDrv <> "" Then
                drvDrive.Drive = oldDrv
            End If
            Exit Sub
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Changing drive")
        Case vbRetry
            Resume
        Case vbCancel
            If oldDrv <> "" Then
                drvDrive.Drive = oldDrv
            End If
            Exit Sub
        End Select
    End Select

End Sub

Public Sub filFile_Click()
    If frmMain.disableReadId3 = False Then
        Screen.MousePointer = vbHourglass
        frmMain.enableID3 True
        frmMain.enableInfo True
        frmMain.DisplayMarkedFiles
        Screen.MousePointer = vbDefault
    End If
End Sub

Private Sub filFile_DblClick()
    runMp3Player
End Sub

Private Sub filFile_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
    'return
        KeyAscii = 0
        runMp3Player
    End If
End Sub

Private Sub filFile_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim ShiftDown, AltDown, CtrlDown, txt As Boolean
    Dim i As Integer
    ShiftDown = (Shift And vbShiftMask) > 0
    AltDown = (Shift And vbAltMask) > 0
    CtrlDown = (Shift And vbCtrlMask) > 0
    
    If CtrlDown And Not ShiftDown And Not AltDown And KeyCode = vbKeyA Then
        'mark all files
        frmMain.disableReadId3 = True
        Screen.MousePointer = vbHourglass
        For i = 0 To filFile.listcount - 1
            filFile.selected(i) = True
        Next i
        Screen.MousePointer = vbDefault
        frmMain.disableReadId3 = False
        filFile_Click
    ElseIf CtrlDown And Not ShiftDown And Not AltDown And KeyCode = vbKeyP Then
        frmFile.runMp3Player
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode <> vbFormMDIForm Then
        'close only when MDI form closes
        WindowState = vbMinimized
        Cancel = 1
    End If
End Sub

Private Sub Form_Resize()
    
    If WindowState <> vbNormal Then
        Exit Sub
    End If
    
    If Width < 1680 Then
        Width = 1680
    End If
    If Height < 2870 Then
        Height = 2870
    End If
    
    lblDrive.Left = 120
    lblDrive.Top = 120
    
    drvDrive.Left = 120
    drvDrive.Top = 360
    drvDrive.Width = Width - 240
    
    lblDir.Left = 120
    lblDir.Top = 840
    
    dirDir.Left = 120
    dirDir.Top = 1080
    dirDir.Width = Width - 240
    dirDir.Height = (0.45 * Height) - 1080
    
    lblRecurs.Left = 120
    lblRecurs.Top = 1080
    lblRecurs.Width = dirDir.Width
    lblRecurs.Height = dirDir.Height
    
    lblFile.Left = 120
    lblFile.Top = dirDir.Top + dirDir.Height + 120
    
    filFile.Left = 120
    filFile.Top = lblFile.Top + lblFile.Height
    filFile.Height = ScaleHeight - filFile.Top
    filFile.Width = ScaleWidth - 240
    
    lstRecursFiles.Left = filFile.Left
    lstRecursFiles.Top = filFile.Top
    lstRecursFiles.Width = filFile.Width
    lstRecursFiles.Height = filFile.Height
    
End Sub

Public Sub lblRecurs_Click()
    'end recursive mode
    
    On Error GoTo error
    
    frmMain.mnuEditRecurs.Checked = False
    lblDrive.Enabled = True
    drvDrive.Enabled = True
    dirDir.Visible = True
    lblRecurs.Visible = False
    filFile.Visible = True
    lstRecursFiles.Visible = False
    lblDir.caption = "Directory:"
    dirDir.Refresh
    filFile.Refresh
    dirDir_Change
    filFile_Click
    Exit Sub
    
error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatFile
        Select Case FileError(Err.Number, "Refresh")
        Case vbRetry
            Resume
        Case vbCancel
            Exit Sub
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Refresh")
        Case vbRetry
            Resume
        Case vbCancel
            Exit Sub
        End Select
    End Select
End Sub

Public Sub lstRecursFiles_Click()
    If frmMain.disableReadId3 = False Then
        Screen.MousePointer = vbHourglass
        frmMain.enableID3 True
        frmMain.enableInfo True
        frmMain.DisplayMarkedFiles
        Screen.MousePointer = vbDefault
    End If
End Sub

Private Sub lstRecursFiles_DblClick()
    runMp3Player
End Sub

Private Sub lstRecursFiles_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
    'return
        KeyAscii = 0
        runMp3Player
    End If
End Sub

Private Sub lstRecursFiles_KeyUp(KeyCode As Integer, Shift As Integer)
    Dim ShiftDown, AltDown, CtrlDown, txt As Boolean
    Dim i As Integer
    ShiftDown = (Shift And vbShiftMask) > 0
    AltDown = (Shift And vbAltMask) > 0
    CtrlDown = (Shift And vbCtrlMask) > 0
    
    frmMain.disableReadId3 = True
    If CtrlDown And Not ShiftDown And Not AltDown And KeyCode = vbKeyA Then
        'mark all files
        Screen.MousePointer = vbHourglass
        For i = 0 To lstRecursFiles.listcount - 1
            lstRecursFiles.selected(i) = True
        Next i
        Screen.MousePointer = vbDefault
    End If
    frmMain.disableReadId3 = False
    lstRecursFiles_Click
End Sub
